/********************************** (C) COPYRIGHT *******************************
* File Name          : RTC.c
* Author             : WCH
* Version            : V1.1
* Date               : 2019/11/05
* Description        : RTCüʼ
*******************************************************************************/

/******************************************************************************/
/* ͷļ */
#include "CH57x_common.h"
#include "HAL.h"

/*********************************************************************
 * CONSTANTS
 */
#define RTC_INIT_TIME_HOUR              0
#define RTC_INIT_TIME_MINUTE            0
#define RTC_INIT_TIME_SECEND            0

/***************************************************
 * Global variables
 */
u32V RTCTigFlag;
pfnTIMHandleCB_t  pTIMHandleCB;

/*******************************************************************************
* Function Name  : RTC_SetTignTime
* Description    : RTCʱ
* Input          : 
* Output         : None
* Return         : None
*******************************************************************************/
void RTC_SetTignTime( u32 time )
{
	if( time&0xffff ) time += (1<<16); 
	R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;		
	R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;
	R32_RTC_TRIG       = time;
	RTCTigFlag = 0;
}

/*******************************************************************************
 * @fn          RTC_IRQHandler
 *
 * @brief       RTCжϴ
 *
 * input parameters
 *
 * @param       None.
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      None.
 */
void RTC_IRQHandler( void )
{
	R8_RTC_FLAG_CTRL =(RB_RTC_TMR_CLR|RB_RTC_TRIG_CLR);
	RTCTigFlag = 1;
	if( pTIMHandleCB ) pTIMHandleCB();
}

/*******************************************************************************
 * @fn          HAL_Time0Init
 *
 * @brief       ϵͳʱʼ
 *
 * input parameters
 *
 * @param       None.
 *
 * output parameters
 *
 * @param       None.
 *
 * @return      None.
 */
void HAL_TimeInit( void )
{
#if( CLK_OSC32K_RC )
  Calibration_LSI();
#else
  R8_SAFE_ACCESS_SIG = 0x57; 
  R8_SAFE_ACCESS_SIG = 0xa8;
  R8_CK32K_CONFIG    |= RB_CLK_OSC32K_XT | RB_CLK_INT32K_PON | RB_CLK_XT32K_PON;
  R8_SAFE_ACCESS_SIG = 0;
#endif
  RTC_InitTime( RTC_INIT_TIME_HOUR, RTC_INIT_TIME_MINUTE, RTC_INIT_TIME_SECEND ); //RTCʱӳʼǰʱ
  pTIMHandleCB = TMOS_TimerInit( 1 );
  R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG1;		
  R8_SAFE_ACCESS_SIG = SAFE_ACCESS_SIG2;
  R8_RTC_MODE_CTRL  |= RB_RTC_TRIG_EN;	// ģʽ
  R8_SAFE_ACCESS_SIG = 0;						// 
  NVIC_EnableIRQ(RTC_IRQn);	
}

/******************************** endfile @ time ******************************/
